Index: core/pom.xml
===================================================================
--- core/pom.xml	(revision 1315)
+++ core/pom.xml	(working copy)
@@ -15,20 +15,11 @@
    <name>Infinispan Core</name>
    <description>Infinispan core module</description>
 
-   <properties>
-      <version.jboss.common.core>2.2.14.GA</version.jboss.common.core>
-      <version.jboss.marshalling>1.2.0.GA</version.jboss.marshalling>
-      <version.jgroups>2.8.0.GA</version.jgroups>
-      <version.jta>1.0.1.GA</version.jta>
-      <version.org.jboss.naming>5.0.3.GA</version.org.jboss.naming>
-      <version.rhq.pluginAnnotations>1.4.0.B01</version.rhq.pluginAnnotations>
-   </properties>
-
    <dependencies>
+   
       <dependency>
          <groupId>jgroups</groupId>
          <artifactId>jgroups</artifactId>
-         <version>${version.jgroups}</version>
       </dependency>
 
       <!--
@@ -38,48 +29,42 @@
       <dependency>
          <groupId>org.jboss.javaee</groupId>
          <artifactId>jboss-transaction-api</artifactId>
-         <version>${version.jta}</version>
       </dependency>
 
       <dependency>
          <groupId>org.jboss.marshalling</groupId>
          <artifactId>river</artifactId>
-         <version>${version.jboss.marshalling}</version>
       </dependency>
 
       <dependency>
          <groupId>org.jboss</groupId>
          <artifactId>jboss-common-core</artifactId>
-         <version>${version.jboss.common.core}</version>
       </dependency>
 
       <dependency>
          <groupId>org.jboss.marshalling</groupId>
          <artifactId>marshalling-api</artifactId>
-         <version>${version.jboss.marshalling}</version>
       </dependency>
 
       <dependency>
          <groupId>org.rhq.helpers</groupId>
          <artifactId>rhq-pluginAnnotations</artifactId>
-         <version>${version.rhq.pluginAnnotations}</version>
       </dependency>
 
       <dependency>
          <groupId>org.jboss.naming</groupId>
          <artifactId>jnp-client</artifactId>
          <scope>test</scope>
-         <version>${version.org.jboss.naming}</version>
       </dependency>
 
       <dependency>
          <groupId>org.jboss.naming</groupId>
          <artifactId>jnpserver</artifactId>
          <scope>test</scope>
-         <version>${version.org.jboss.naming}</version>
       </dependency>
 
    </dependencies>
+   
    <build>
       <plugins>
          <!--
Index: parent/pom.xml
===================================================================
--- parent/pom.xml	(revision 1315)
+++ parent/pom.xml	(working copy)
@@ -65,63 +65,61 @@
    <properties>
       <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
       <defaultTestGroup>functional,unit</defaultTestGroup>
+      <version.jboss.common.core>2.2.14.GA</version.jboss.common.core>
+      <version.jboss.marshalling>1.2.0.GA</version.jboss.marshalling>
+      <version.jboss.jbossts>4.9.0.GA</version.jboss.jbossts>
+      <version.jgroups>2.8.0.GA</version.jgroups>
+      <version.jta>1.0.1.GA</version.jta>
+      <version.org.jboss.naming>5.0.3.GA</version.org.jboss.naming>
+      <version.rhq.pluginAnnotations>1.4.0.B01</version.rhq.pluginAnnotations>
    </properties>
 
-
+   <!-- global test and optional dependencies -->
    <dependencies>
       <dependency>
          <groupId>org.testng</groupId>
          <artifactId>testng</artifactId>
-         <version>5.9</version>
          <scope>test</scope>
          <classifier>jdk15</classifier>
       </dependency>
       <dependency>
          <groupId>net.jcip</groupId>
          <artifactId>jcip-annotations</artifactId>
-         <version>1.0</version>
          <optional>true</optional>
       </dependency>
       <dependency>
          <groupId>org.easymock</groupId>
          <artifactId>easymockclassextension</artifactId>
-         <version>2.4</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>org.easymock</groupId>
          <artifactId>easymock</artifactId>
-         <version>2.4</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>jboss.jbossts</groupId>
          <artifactId>jbossjta</artifactId>
-         <version>4.9.0.GA</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>jboss.jbossts</groupId>
          <artifactId>jbossjts</artifactId>
-         <version>4.9.0.GA</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>commons-logging</groupId>
          <artifactId>commons-logging</artifactId>
-         <version>1.1</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>jboss.jbossts</groupId>
          <artifactId>jbossts-common</artifactId>
-         <version>4.6.1.GA</version>
          <scope>test</scope>
       </dependency>
       <dependency>
          <groupId>log4j</groupId>
          <artifactId>log4j</artifactId>
-         <version>1.2.14</version>
          <scope>provided</scope>
       </dependency>
 
@@ -129,11 +127,125 @@
       <dependency>
          <groupId>com.thoughtworks.xstream</groupId>
          <artifactId>xstream</artifactId>
-         <version>1.3.1</version>
          <scope>test</scope>
       </dependency>
    </dependencies>
 
+   <!-- Versions for dependencies shared across most modules -->
+   <dependencyManagement>
+      <dependencies>
+
+         <!-- core dependencies -->
+
+         <dependency>
+            <groupId>jgroups</groupId>
+            <artifactId>jgroups</artifactId>
+            <version>${version.jgroups}</version>
+         </dependency>
+
+         <dependency>
+            <groupId>org.jboss.javaee</groupId>
+            <artifactId>jboss-transaction-api</artifactId>
+            <version>${version.jta}</version>
+         </dependency>
+
+         <dependency>
+            <groupId>org.jboss.marshalling</groupId>
+            <artifactId>river</artifactId>
+            <version>${version.jboss.marshalling}</version>
+         </dependency>
+
+         <dependency>
+            <groupId>org.jboss</groupId>
+            <artifactId>jboss-common-core</artifactId>
+            <version>${version.jboss.common.core}</version>
+         </dependency>
+
+         <dependency>
+            <groupId>org.jboss.marshalling</groupId>
+            <artifactId>marshalling-api</artifactId>
+            <version>${version.jboss.marshalling}</version>
+         </dependency>
+
+         <dependency>
+            <groupId>org.rhq.helpers</groupId>
+            <artifactId>rhq-pluginAnnotations</artifactId>
+            <version>${version.rhq.pluginAnnotations}</version>
+         </dependency>
+
+         <!-- test dependencies -->
+         <dependency>
+            <groupId>org.testng</groupId>
+            <artifactId>testng</artifactId>
+            <version>5.9</version>
+            <classifier>jdk15</classifier>
+         </dependency>
+         <dependency>
+            <groupId>net.jcip</groupId>
+            <artifactId>jcip-annotations</artifactId>
+            <version>1.0</version>
+         </dependency>
+         <dependency>
+            <groupId>org.easymock</groupId>
+            <artifactId>easymockclassextension</artifactId>
+            <version>2.4</version>
+         </dependency>
+         <dependency>
+            <groupId>org.easymock</groupId>
+            <artifactId>easymock</artifactId>
+            <version>2.4</version>
+         </dependency>
+         <dependency>
+            <groupId>jboss.jbossts</groupId>
+            <artifactId>jbossjta</artifactId>
+            <version>${version.jboss.jbossts}</version>
+         </dependency>
+         <dependency>
+            <groupId>jboss.jbossts</groupId>
+            <artifactId>jbossjts</artifactId>
+            <version>${version.jboss.jbossts}</version>
+         </dependency>
+         <dependency>
+            <groupId>commons-logging</groupId>
+            <artifactId>commons-logging</artifactId>
+            <version>1.1</version>
+         </dependency>
+         <dependency>
+            <groupId>jboss.jbossts</groupId>
+            <artifactId>jbossts-common</artifactId>
+            <version>4.6.1.GA</version>
+         </dependency>
+         <dependency>
+            <groupId>log4j</groupId>
+            <artifactId>log4j</artifactId>
+            <version>1.2.14</version>
+         </dependency>
+         <dependency>
+            <groupId>org.jboss.naming</groupId>
+            <artifactId>jnp-client</artifactId>
+            <version>${version.org.jboss.naming}</version>
+         </dependency>
+         <dependency>
+            <groupId>org.jboss.naming</groupId>
+            <artifactId>jnpserver</artifactId>
+            <version>${version.org.jboss.naming}</version>
+         </dependency>
+         <dependency>
+            <groupId>javax.servlet</groupId>
+            <artifactId>servlet-api</artifactId>
+            <version>2.5</version>
+            <scope>provided</scope>
+         </dependency>
+
+         <!-- used to serialize non-serializable objects for a dummy marshaller -->
+         <dependency>
+            <groupId>com.thoughtworks.xstream</groupId>
+            <artifactId>xstream</artifactId>
+            <version>1.3.1</version>
+         </dependency>
+      </dependencies>
+   </dependencyManagement>
+
    <build>
       <plugins>
          <!-- enforce java 1.6 and maven 2.1.0 -->
Index: server/rest/pom.xml
===================================================================
--- server/rest/pom.xml	(revision 1315)
+++ server/rest/pom.xml	(working copy)
@@ -91,13 +91,13 @@
       <dependency>
          <groupId>com.thoughtworks.xstream</groupId>
          <artifactId>xstream</artifactId>
-         <version>1.3.1</version>
+         <!-- version defined in parent pom -->
       </dependency>
 
       <dependency>
          <groupId>javax.servlet</groupId>
          <artifactId>servlet-api</artifactId>
-         <version>2.5</version>
+         <!-- version defined in parent pom -->
          <scope>provided</scope>
       </dependency>
 
Index: demos/ec2/pom.xml
===================================================================
--- demos/ec2/pom.xml	(revision 1315)
+++ demos/ec2/pom.xml	(working copy)
@@ -45,7 +45,6 @@
 		<dependency>
 			<groupId>commons-logging</groupId>
 			<artifactId>commons-logging</artifactId>
-			<version>1.1</version>
 		</dependency>
       <dependency>
          <groupId>javax.servlet</groupId>
Index: demos/lucene-directory/pom.xml
===================================================================
--- demos/lucene-directory/pom.xml	(revision 1315)
+++ demos/lucene-directory/pom.xml	(working copy)
@@ -12,8 +12,8 @@
 
    <artifactId>infinispan-lucene-demo</artifactId>
    <version>4.0.0-SNAPSHOT</version>
-   <name>Infinispan Directory Demo</name>
-   <description>Infinispan - Directory Demo</description>
+   <name>Infinispan Lucene Directory Demo</name>
+   <description>Infinispan - Lucene Directory Demo</description>
 
    <dependencies>
       <dependency>
@@ -24,22 +24,18 @@
       <dependency>
          <groupId>jboss.jbossts</groupId>
          <artifactId>jbossjts</artifactId>
-         <version>4.6.1.GA</version>
       </dependency>
       <dependency>
          <groupId>jboss.jbossts</groupId>
          <artifactId>jbossts-common</artifactId>
-         <version>4.6.1.GA</version>
       </dependency>
       <dependency>
          <groupId>commons-logging</groupId>
          <artifactId>commons-logging</artifactId>
-         <version>1.1</version>
       </dependency>
       <dependency>
          <groupId>log4j</groupId>
          <artifactId>log4j</artifactId>
-         <version>1.2.14</version>
       </dependency>
       <dependency>
          <groupId>${project.groupId}</groupId>
Index: lucene-directory/pom.xml
===================================================================
--- lucene-directory/pom.xml	(revision 1315)
+++ lucene-directory/pom.xml	(working copy)
@@ -45,7 +45,6 @@
          <plugin>
             <groupId>org.apache.maven.plugins</groupId>
             <artifactId>maven-surefire-plugin</artifactId>
-            <version>2.4.3</version>
             <configuration>
                <excludes>
                   <exclude>**/*StressTest.java</exclude>