From 39d2ef8d5607ca0738910f4a2c9bcb4659f6c227 Mon Sep 17 00:00:00 2001
From: Oved Ourfali <ovedo@redhat.com>
Date: Thu, 16 Feb 2012 09:18:05 +0200
Subject: [PATCH 3/3] adding org.jboss.metadata to minimal build

---
 build/build.xml |   16 ++++++++--------
 build/pom.xml   |   50 +++++++++++++++++++++++++-------------------------
 2 files changed, 33 insertions(+), 33 deletions(-)

diff --git a/build/build.xml b/build/build.xml
index 33ff383..13c8c81 100644
--- a/build/build.xml
+++ b/build/build.xml
@@ -214,6 +214,14 @@
             <maven-resource group="org.jboss.marshalling" artifact="jboss-marshalling-river"/>
         </module-def>
 
+        <module-def name="org.jboss.metadata">
+            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-common"/>
+            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-appclient"/>
+            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-ejb"/>
+            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-web"/>
+            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-ear"/>
+        </module-def>
+
         <module-def name="org.jboss.modules"/>
 
         <module-def name="org.jboss.msc">
@@ -915,14 +923,6 @@
             <maven-resource group="org.jboss.jbossts" artifact="jbossjts-integration"/>
         </module-def>
 
-        <module-def name="org.jboss.metadata">
-            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-common"/>
-            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-appclient"/>
-            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-ejb"/>
-            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-web"/>
-            <maven-resource group="org.jboss.metadata" artifact="jboss-metadata-ear"/>
-        </module-def>
-
         <module-def name="org.jboss.netty">
             <maven-resource group="org.jboss.netty" artifact="netty"/>
         </module-def>
diff --git a/build/pom.xml b/build/pom.xml
index e0d4a02..144d13a 100644
--- a/build/pom.xml
+++ b/build/pom.xml
@@ -160,6 +160,31 @@
         </dependency>
 
         <dependency>
+            <groupId>org.jboss.metadata</groupId>
+            <artifactId>jboss-metadata-appclient</artifactId>
+        </dependency>
+
+        <dependency>
+            <groupId>org.jboss.metadata</groupId>
+            <artifactId>jboss-metadata-common</artifactId>
+        </dependency>
+
+        <dependency>
+            <groupId>org.jboss.metadata</groupId>
+            <artifactId>jboss-metadata-ear</artifactId>
+        </dependency>
+
+        <dependency>
+            <groupId>org.jboss.metadata</groupId>
+            <artifactId>jboss-metadata-ejb</artifactId>
+        </dependency>
+
+        <dependency>
+            <groupId>org.jboss.metadata</groupId>
+            <artifactId>jboss-metadata-web</artifactId>
+        </dependency>
+
+        <dependency>
             <groupId>org.jboss.modules</groupId>
             <artifactId>jboss-modules</artifactId>
         </dependency>
@@ -1065,31 +1090,6 @@
                 </dependency>
 
                 <dependency>
-                    <groupId>org.jboss.metadata</groupId>
-                    <artifactId>jboss-metadata-appclient</artifactId>
-                </dependency>
-
-                <dependency>
-                    <groupId>org.jboss.metadata</groupId>
-                    <artifactId>jboss-metadata-common</artifactId>
-                </dependency>
-
-                <dependency>
-                    <groupId>org.jboss.metadata</groupId>
-                    <artifactId>jboss-metadata-ear</artifactId>
-                </dependency>
-
-                <dependency>
-                    <groupId>org.jboss.metadata</groupId>
-                    <artifactId>jboss-metadata-ejb</artifactId>
-                </dependency>
-
-                <dependency>
-                    <groupId>org.jboss.metadata</groupId>
-                    <artifactId>jboss-metadata-web</artifactId>
-                </dependency>
-
-                <dependency>
                     <groupId>org.jboss.mod_cluster</groupId>
                     <artifactId>mod_cluster-container-spi</artifactId>
                     <version>${version.org.jboss.mod_cluster}</version>
-- 
1.7.9